/*
 * assabet.c: Assabet specific stuff
 *
 * Copyright (C) 2001  Erik Mouw (J.A.K.Mouw@its.tudelft.nl)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ident "$Id: assabet.c,v 1.6 2002/01/03 16:07:17 erikm Exp $"

#ifdef HAVE_CONFIG_H
# include <blob/config.h>
#endif

#include <blob/flash.h>
#include <blob/init.h>
#include <blob/serial.h>




/* flash descriptor for Assabet flash */
/* 2x Intel 28F128J3A strataflash (16MB) */
static flash_descriptor_t assabet_flash_descriptors[] =
{
	{
		size: 2 * 128 * 1024,
		num: 64,
		lockable: 1
	},
	{
		/* NULL block */
	},
};




static void init_assabet_flash_driver(void)
{
	flash_descriptors = assabet_flash_descriptors;
	flash_driver = &intel32_flash_driver;
}

__initlist(init_assabet_flash_driver, INIT_LEVEL_DRIVER_SELECTION);




#define RS232_ENABLE		0x00001000
#define GREEN_LED_ENABLE	0x00004000

static void assabet_init_hardware(void)
{
	u32 *bcr = (u32 *)0x12000000;
	
	/* enable RS232 tranceiver and green LED */
	*bcr = RS232_ENABLE | GREEN_LED_ENABLE;

	/* select serial driver */
	serial_driver = &sa11x0_serial_driver;
}


__initlist(assabet_init_hardware, INIT_LEVEL_DRIVER_SELECTION);
