/*
 * idr.c: Vercel UD-1 (IDR) specific stuff
 *
 * Copyright (C) 2001 Tim Riker <Tim@Rikers.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ident "$Id: idr.c,v 1.4 2002/01/03 16:07:17 erikm Exp $"

#ifdef HAVE_CONFIG_H
# include <blob/config.h>
#endif

#include <blob/flash.h>
#include <blob/init.h>
#include <blob/serial.h>

/* flash descriptor for IDR flash */
/* 1x Intel 28F128J3A strataflash (16MB) */
static flash_descriptor_t idr_flash_descriptors[] =
{
	{
		size: 128 * 1024,
		num: 128,
		lockable: 1
	},
	{
		/* NULL block */
	},
};

static void init_idr_flash_driver(void)
{
	flash_descriptors = idr_flash_descriptors;
	flash_driver = &intel16_flash_driver;
}

__initlist(init_idr_flash_driver, INIT_LEVEL_DRIVER_SELECTION);


static void idr_init_hardware(void)
{
	/* select serial driver */
	serial_driver = &sa11x0_serial_driver;
}

__initlist(idr_init_hardware, INIT_LEVEL_DRIVER_SELECTION);
