/*
 * shannon.c: SHANNON specific stuff
 *
 * Copyright (C) 2001  Erik Mouw (J.A.K.Mouw@its.tudelft.nl)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ident "$Id: shannon.c,v 1.6 2002/01/03 16:07:18 erikm Exp $"

#ifdef HAVE_CONFIG_H
# include <blob/config.h>
#endif

#include <blob/flash.h>
#include <blob/init.h>
#include <blob/serial.h>




/* flash descriptor for SHANNON flash */
/* 2x AMD *whatever* flash (4MB) */
static flash_descriptor_t shannon_flash_descriptors[] =
{
	{ 
		size: 2 * 8 * 1024,
		num: 8,
	},
	{
		size: 2 * 64 * 1024,
		num: 31,
	},
	{
		/* NULL block */
	},
};




static void init_shannon_flash_driver(void)
{
	flash_descriptors = shannon_flash_descriptors;
	flash_driver = &amd32_flash_driver;
}

__initlist(init_shannon_flash_driver, INIT_LEVEL_DRIVER_SELECTION);




static void shannon_init_hardware(void)
{
	/* select serial driver */
	serial_driver = &sa11x0_serial_driver;
}

__initlist(shannon_init_hardware, INIT_LEVEL_DRIVER_SELECTION);
